diff --git a/scripts/qapi/commands.py b/scripts/qapi/commands.py
index cffed6cd3ba..b01de93c965 100644
--- a/scripts/qapi/commands.py
+++ b/scripts/qapi/commands.py
@@ -13,6 +13,8 @@
 See the COPYING file in the top-level directory.
 """
 
+# pylint: disable=missing-docstring
+
 from typing import (
     Dict,
     List,
diff --git a/scripts/qapi/common.py b/scripts/qapi/common.py
index 444b3acf53a..918a1ab728a 100644
--- a/scripts/qapi/common.py
+++ b/scripts/qapi/common.py
@@ -11,6 +11,8 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
+# pylint: disable=missing-docstring
+
 import re
 import sys
 from typing import (
diff --git a/scripts/qapi/events.py b/scripts/qapi/events.py
index 36dc0c50c78..9ab9ff4e695 100644
--- a/scripts/qapi/events.py
+++ b/scripts/qapi/events.py
@@ -12,6 +12,8 @@
 See the COPYING file in the top-level directory.
 """
 
+# pylint: disable=missing-docstring
+
 from typing import List, Optional
 
 from .common import c_enum_const, c_name, mcgen
diff --git a/scripts/qapi/expr.py b/scripts/qapi/expr.py
index f60e580dd36..c137dcf950a 100644
--- a/scripts/qapi/expr.py
+++ b/scripts/qapi/expr.py
@@ -13,6 +13,8 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
+# pylint: disable=missing-docstring
+
 """
 Normalize and validate (context-free) QAPI schema expression structures.
 
diff --git a/scripts/qapi/gen.py b/scripts/qapi/gen.py
index ce94aee8e70..f869c751e53 100644
--- a/scripts/qapi/gen.py
+++ b/scripts/qapi/gen.py
@@ -11,6 +11,8 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
+# pylint: disable=missing-docstring
+
 from contextlib import contextmanager
 import os
 import re
diff --git a/scripts/qapi/introspect.py b/scripts/qapi/introspect.py
index 9d499f90b7c..44edc42d18b 100644
--- a/scripts/qapi/introspect.py
+++ b/scripts/qapi/introspect.py
@@ -11,6 +11,8 @@
 See the COPYING file in the top-level directory.
 """
 
+# pylint: disable=missing-docstring
+
 from typing import (
     Any,
     Dict,
diff --git a/scripts/qapi/main.py b/scripts/qapi/main.py
index 316736b6a29..24ffa15aa2c 100644
--- a/scripts/qapi/main.py
+++ b/scripts/qapi/main.py
@@ -7,6 +7,8 @@
 This is the main entry point for generating C code from the QAPI schema.
 """
 
+# pylint: disable=missing-docstring
+
 import argparse
 import sys
 from typing import Optional
diff --git a/scripts/qapi/parser.py b/scripts/qapi/parser.py
index 9bb039fe8d3..9113c9d1506 100644
--- a/scripts/qapi/parser.py
+++ b/scripts/qapi/parser.py
@@ -14,6 +14,8 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
+# pylint: disable=missing-docstring
+
 from collections import OrderedDict
 import os
 import re
diff --git a/scripts/qapi/schema.py b/scripts/qapi/schema.py
index d65c35f6ee6..a06b3e30ffd 100644
--- a/scripts/qapi/schema.py
+++ b/scripts/qapi/schema.py
@@ -12,7 +12,7 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
-# pylint: disable=too-many-lines
+# pylint: disable=too-many-lines, missing-docstring
 
 # TODO catching name collisions in generated code would be nice
 
diff --git a/scripts/qapi/source.py b/scripts/qapi/source.py
index 7b379fdc925..ad7f4e1a0e5 100644
--- a/scripts/qapi/source.py
+++ b/scripts/qapi/source.py
@@ -9,6 +9,8 @@
 # This work is licensed under the terms of the GNU GPL, version 2.
 # See the COPYING file in the top-level directory.
 
+# pylint: disable=missing-docstring
+
 import copy
 from typing import List, Optional, TypeVar
 
diff --git a/scripts/qapi/types.py b/scripts/qapi/types.py
index 0dd0b00ada3..abba5983870 100644
--- a/scripts/qapi/types.py
+++ b/scripts/qapi/types.py
@@ -13,6 +13,8 @@
 # See the COPYING file in the top-level directory.
 """
 
+# pylint: disable=missing-docstring
+
 from typing import List, Optional
 
 from .common import c_enum_const, c_name, mcgen
diff --git a/scripts/qapi/visit.py b/scripts/qapi/visit.py
index 20ce6be9978..851f3b01e97 100644
--- a/scripts/qapi/visit.py
+++ b/scripts/qapi/visit.py
@@ -13,6 +13,8 @@
 See the COPYING file in the top-level directory.
 """
 
+# pylint: disable=missing-docstring
+
 from typing import List, Optional
 
 from .common import (